Imports System.Text
Imports System.Threading.Tasks
Imports System.Web.Http

Namespace HalMediaType
	Public Class ProductCatalogController
		Inherits ApiController

        Public Function Get_ext() As Products
            Dim products = GetProducts()
            Return products
        End Function

        Public Function Get_ext(ByVal id As Integer) As Product
            Dim products = GetProducts()
            Return products.FirstOrDefault(Function(p) p.Id = id)
        End Function

		Private Function GetProducts() As Products
			Dim products = New Products From {
				New Product With {.Id = 1, .Name = "Product 1", .UnitPrice = 5.34D},
				New Product With {.Id = 2, .Name = "Product 2", .UnitPrice = 10} }

			For Each product In products
				product.HRef = Url.Route("products", New With {Key .id = product.Id})

                Dim addCart = New Link With {.Rel = "add-cart", .HRef = Url.Route("cart", New With {products})}

                product.privateLinks.Add(addCart)
			Next product

            products.HRef = Url.Route("products", New With {products})

			Return products
		End Function
	End Class
End Namespace
