Imports System.Text
Imports System.Threading.Tasks
Imports System.Web.Http
Imports System.Web.Http.SelfHost

Namespace HalMediaType
	Friend Class Program
		Shared Sub Main(ByVal args() As String)
			Dim config = New HttpSelfHostConfiguration("http://localhost:8091")

			config.Routes.MapHttpRoute("products", "api/products/{id}", New With {Key .controller = "ProductCatalog", Key .id = RouteParameter.Optional})

			config.Routes.MapHttpRoute("cart", "api/cart/{id}", New With {Key .controller = "Cart", Key .id = RouteParameter.Optional})

			config.Routes.MapHttpRoute("API Default", "api/{controller}/{id}", New With {Key .id = RouteParameter.Optional})

			config.Formatters.Clear()
			config.Formatters.Add(New HalXmlMediaTypeFormatter)

			Using server As New HttpSelfHostServer(config)
				server.OpenAsync.Wait()
				Console.WriteLine("Press Enter to quit.")
				Console.ReadLine()
			End Using
		End Sub
	End Class
End Namespace
